DROP TABLE IF EXISTS PROVIDER_CONFIGURATIONS;

CREATE TABLE PROVIDER_CONFIGURATIONS (
-- Primary key
  PROVIDER_NAME varchar(255),
-- Autodiscovery configuration
  MULTIDISCOVERY BOOLEAN,
-- Sign in configurations
  SIGN_IN_URL varchar(512),
  SIGN_UP_URL varchar(512),
  POST_SIGN_IN_URL varchar(512),
  
  PRIMARY KEY (PROVIDER_NAME)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

DROP TABLE IF EXISTS PROVIDER_MERGE_CONFIGURATIONS;

-- Merge configurations
CREATE TABLE PROVIDER_MERGE_CONFIGURATIONS (
  PROVIDER_NAME varchar(255),
  PROVIDER_ID varchar(255),
  PRIORITY int(11),
  
  PRIMARY KEY (PROVIDER_NAME, PROVIDER_ID)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

DROP TABLE IF EXISTS PROVIDER_CALLBACK_CONFIGURATIONS;

-- Callback configurations
CREATE TABLE PROVIDER_CALLBACK_CONFIGURATIONS (
  PROVIDER_NAME varchar(255),
  EVENT varchar(255),
  DELIVERY_CHANNEL varchar(32),
  DELIVERY_FORMAT varchar(32),
  PRIMARY KEY (PROVIDER_NAME, EVENT, DELIVERY_CHANNEL, DELIVERY_FORMAT)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;